/* A Bison parser, made by GNU Bison 3.6.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2020 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.6.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         parserparse
#define yylex           parserlex
#define yyerror         parsererror
#define yydebug         parserdebug
#define yynerrs         parsernerrs
#define yylval          parserlval
#define yychar          parserchar
#define yylloc          parserlloc

/* First part of user prologue.  */
#line 29 "src/parser.y"


#include <sys/types.h>
#include <sys/stat.h>
#ifdef _MSC_VER
#define strdup _strdup
#else
#include <unistd.h>
#endif

#include "FileModule.h"
#include "UserModule.h"
#include "ModuleInstantiation.h"
#include "Assignment.h"
#include "expression.h"
#include "value.h"
#include "function.h"
#include "printutils.h"
#include "memory.h"
#include <sstream>
#include <stack>
#include <boost/filesystem.hpp>
#include "boost-utils.h"

namespace fs = boost::filesystem;

#define YYMAXDEPTH 20000
#define LOC(loc) Location(loc.first_line, loc.first_column, loc.last_line, loc.last_column, sourcefile())
  
int parser_error_pos = -1;

int parserlex(void);
void yyerror(char const *s);

int lexerget_lineno(void);
std::shared_ptr<fs::path> sourcefile(void);
void lexer_set_parser_sourcefile(const fs::path& path);
int lexerlex_destroy(void);
int lexerlex(void);

std::stack<LocalScope *> scope_stack;
FileModule *rootmodule;

extern void lexerdestroy();
extern FILE *lexerin;
const char *parser_input_buffer;
static fs::path mainFilePath;
static std::string main_file_folder;

bool fileEnded=false;

#line 131 "objects/parser.cxx"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_PARSER_OBJECTS_PARSER_HXX_INCLUDED
# define YY_PARSER_OBJECTS_PARSER_HXX_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif
#if YYDEBUG
extern int parserdebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    TOK_ERROR = 258,               /* TOK_ERROR  */
    TOK_EOT = 259,                 /* TOK_EOT  */
    TOK_MODULE = 260,              /* TOK_MODULE  */
    TOK_FUNCTION = 261,            /* TOK_FUNCTION  */
    TOK_IF = 262,                  /* TOK_IF  */
    TOK_ELSE = 263,                /* TOK_ELSE  */
    TOK_FOR = 264,                 /* TOK_FOR  */
    TOK_LET = 265,                 /* TOK_LET  */
    TOK_ASSERT = 266,              /* TOK_ASSERT  */
    TOK_ECHO = 267,                /* TOK_ECHO  */
    TOK_EACH = 268,                /* TOK_EACH  */
    TOK_ID = 269,                  /* TOK_ID  */
    TOK_STRING = 270,              /* TOK_STRING  */
    TOK_USE = 271,                 /* TOK_USE  */
    TOK_NUMBER = 272,              /* TOK_NUMBER  */
    TOK_TRUE = 273,                /* TOK_TRUE  */
    TOK_FALSE = 274,               /* TOK_FALSE  */
    TOK_UNDEF = 275,               /* TOK_UNDEF  */
    LE = 276,                      /* LE  */
    GE = 277,                      /* GE  */
    EQ = 278,                      /* EQ  */
    NE = 279,                      /* NE  */
    AND = 280,                     /* AND  */
    OR = 281,                      /* OR  */
    LET = 282,                     /* LET  */
    LOW_PRIO_RIGHT = 283,          /* LOW_PRIO_RIGHT  */
    LOW_PRIO_LEFT = 284,           /* LOW_PRIO_LEFT  */
    UNARY = 285,                   /* UNARY  */
    HIGH_PRIO_RIGHT = 286,         /* HIGH_PRIO_RIGHT  */
    HIGH_PRIO_LEFT = 287           /* HIGH_PRIO_LEFT  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 81 "src/parser.y"

  char *text;
  double number;
  class Value *value;
  class Expression *expr;
  class Vector *vec;
  class ModuleInstantiation *inst;
  class IfElseModuleInstantiation *ifelse;
  class Assignment *arg;
  AssignmentList *args;

#line 225 "objects/parser.cxx"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


extern YYSTYPE parserlval;
extern YYLTYPE parserlloc;
int parserparse (void);

#endif /* !YY_PARSER_OBJECTS_PARSER_HXX_INCLUDED  */
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_TOK_ERROR = 3,                  /* TOK_ERROR  */
  YYSYMBOL_TOK_EOT = 4,                    /* TOK_EOT  */
  YYSYMBOL_TOK_MODULE = 5,                 /* TOK_MODULE  */
  YYSYMBOL_TOK_FUNCTION = 6,               /* TOK_FUNCTION  */
  YYSYMBOL_TOK_IF = 7,                     /* TOK_IF  */
  YYSYMBOL_TOK_ELSE = 8,                   /* TOK_ELSE  */
  YYSYMBOL_TOK_FOR = 9,                    /* TOK_FOR  */
  YYSYMBOL_TOK_LET = 10,                   /* TOK_LET  */
  YYSYMBOL_TOK_ASSERT = 11,                /* TOK_ASSERT  */
  YYSYMBOL_TOK_ECHO = 12,                  /* TOK_ECHO  */
  YYSYMBOL_TOK_EACH = 13,                  /* TOK_EACH  */
  YYSYMBOL_TOK_ID = 14,                    /* TOK_ID  */
  YYSYMBOL_TOK_STRING = 15,                /* TOK_STRING  */
  YYSYMBOL_TOK_USE = 16,                   /* TOK_USE  */
  YYSYMBOL_TOK_NUMBER = 17,                /* TOK_NUMBER  */
  YYSYMBOL_TOK_TRUE = 18,                  /* TOK_TRUE  */
  YYSYMBOL_TOK_FALSE = 19,                 /* TOK_FALSE  */
  YYSYMBOL_TOK_UNDEF = 20,                 /* TOK_UNDEF  */
  YYSYMBOL_LE = 21,                        /* LE  */
  YYSYMBOL_GE = 22,                        /* GE  */
  YYSYMBOL_EQ = 23,                        /* EQ  */
  YYSYMBOL_NE = 24,                        /* NE  */
  YYSYMBOL_AND = 25,                       /* AND  */
  YYSYMBOL_OR = 26,                        /* OR  */
  YYSYMBOL_LET = 27,                       /* LET  */
  YYSYMBOL_LOW_PRIO_RIGHT = 28,            /* LOW_PRIO_RIGHT  */
  YYSYMBOL_LOW_PRIO_LEFT = 29,             /* LOW_PRIO_LEFT  */
  YYSYMBOL_30_ = 30,                       /* '?'  */
  YYSYMBOL_31_ = 31,                       /* ':'  */
  YYSYMBOL_32_ = 32,                       /* '<'  */
  YYSYMBOL_33_ = 33,                       /* '>'  */
  YYSYMBOL_34_ = 34,                       /* '!'  */
  YYSYMBOL_35_ = 35,                       /* '+'  */
  YYSYMBOL_36_ = 36,                       /* '-'  */
  YYSYMBOL_37_ = 37,                       /* '*'  */
  YYSYMBOL_38_ = 38,                       /* '/'  */
  YYSYMBOL_39_ = 39,                       /* '%'  */
  YYSYMBOL_UNARY = 40,                     /* UNARY  */
  YYSYMBOL_41_ = 41,                       /* '['  */
  YYSYMBOL_42_ = 42,                       /* ']'  */
  YYSYMBOL_43_ = 43,                       /* '.'  */
  YYSYMBOL_HIGH_PRIO_RIGHT = 44,           /* HIGH_PRIO_RIGHT  */
  YYSYMBOL_HIGH_PRIO_LEFT = 45,            /* HIGH_PRIO_LEFT  */
  YYSYMBOL_46_ = 46,                       /* ';'  */
  YYSYMBOL_47_ = 47,                       /* '{'  */
  YYSYMBOL_48_ = 48,                       /* '}'  */
  YYSYMBOL_49_ = 49,                       /* '('  */
  YYSYMBOL_50_ = 50,                       /* ')'  */
  YYSYMBOL_51_ = 51,                       /* '='  */
  YYSYMBOL_52_ = 52,                       /* '#'  */
  YYSYMBOL_53_ = 53,                       /* ','  */
  YYSYMBOL_YYACCEPT = 54,                  /* $accept  */
  YYSYMBOL_input = 55,                     /* input  */
  YYSYMBOL_statement = 56,                 /* statement  */
  YYSYMBOL_57_1 = 57,                      /* $@1  */
  YYSYMBOL_58_2 = 58,                      /* $@2  */
  YYSYMBOL_inner_input = 59,               /* inner_input  */
  YYSYMBOL_assignment = 60,                /* assignment  */
  YYSYMBOL_module_instantiation = 61,      /* module_instantiation  */
  YYSYMBOL_62_3 = 62,                      /* @3  */
  YYSYMBOL_ifelse_statement = 63,          /* ifelse_statement  */
  YYSYMBOL_64_4 = 64,                      /* $@4  */
  YYSYMBOL_if_statement = 65,              /* if_statement  */
  YYSYMBOL_66_5 = 66,                      /* @5  */
  YYSYMBOL_child_statements = 67,          /* child_statements  */
  YYSYMBOL_child_statement = 68,           /* child_statement  */
  YYSYMBOL_module_id = 69,                 /* module_id  */
  YYSYMBOL_single_module_instantiation = 70, /* single_module_instantiation  */
  YYSYMBOL_expr = 71,                      /* expr  */
  YYSYMBOL_expr_or_empty = 72,             /* expr_or_empty  */
  YYSYMBOL_list_comprehension_elements = 73, /* list_comprehension_elements  */
  YYSYMBOL_list_comprehension_elements_p = 74, /* list_comprehension_elements_p  */
  YYSYMBOL_list_comprehension_elements_or_expr = 75, /* list_comprehension_elements_or_expr  */
  YYSYMBOL_optional_commas = 76,           /* optional_commas  */
  YYSYMBOL_vector_expr = 77,               /* vector_expr  */
  YYSYMBOL_arguments_decl = 78,            /* arguments_decl  */
  YYSYMBOL_argument_decl = 79,             /* argument_decl  */
  YYSYMBOL_arguments_call = 80,            /* arguments_call  */
  YYSYMBOL_argument_call = 81              /* argument_call  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_uint8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   698

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  54
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  28
/* YYNRULES -- Number of rules.  */
#define YYNRULES  102
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  209

#define YYMAXUTOK   287


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    34,     2,    52,     2,    39,     2,     2,
      49,    50,    37,    35,    53,    36,    43,    38,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    31,    46,
      32,    51,    33,    30,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    41,     2,    42,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    47,     2,    48,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    40,    44,    45
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   162,   162,   163,   169,   173,   174,   175,   179,   181,
     180,   194,   193,   201,   207,   209,   213,   265,   270,   275,
     280,   286,   285,   295,   302,   307,   306,   319,   318,   330,
     332,   333,   337,   338,   339,   347,   348,   349,   350,   351,
     352,   356,   365,   369,   373,   377,   382,   387,   392,   396,
     400,   404,   408,   412,   416,   420,   424,   428,   432,   436,
     440,   444,   448,   452,   456,   460,   464,   468,   472,   476,
     480,   484,   488,   494,   499,   504,   512,   516,   525,   530,
     534,   547,   553,   557,   565,   566,   573,   574,   578,   579,
     583,   588,   593,   602,   605,   611,   620,   625,   634,   637,
     643,   652,   656
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "TOK_ERROR", "TOK_EOT",
  "TOK_MODULE", "TOK_FUNCTION", "TOK_IF", "TOK_ELSE", "TOK_FOR", "TOK_LET",
  "TOK_ASSERT", "TOK_ECHO", "TOK_EACH", "TOK_ID", "TOK_STRING", "TOK_USE",
  "TOK_NUMBER", "TOK_TRUE", "TOK_FALSE", "TOK_UNDEF", "LE", "GE", "EQ",
  "NE", "AND", "OR", "LET", "LOW_PRIO_RIGHT", "LOW_PRIO_LEFT", "'?'",
  "':'", "'<'", "'>'", "'!'", "'+'", "'-'", "'*'", "'/'", "'%'", "UNARY",
  "'['", "']'", "'.'", "HIGH_PRIO_RIGHT", "HIGH_PRIO_LEFT", "';'", "'{'",
  "'}'", "'('", "')'", "'='", "'#'", "','", "$accept", "input",
  "statement", "$@1", "$@2", "inner_input", "assignment",
  "module_instantiation", "@3", "ifelse_statement", "$@4", "if_statement",
  "@5", "child_statements", "child_statement", "module_id",
  "single_module_instantiation", "expr", "expr_or_empty",
  "list_comprehension_elements", "list_comprehension_elements_p",
  "list_comprehension_elements_or_expr", "optional_commas", "vector_expr",
  "arguments_decl", "argument_decl", "arguments_call", "argument_call", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
      63,    58,    60,    62,    33,    43,    45,    42,    47,    37,
     285,    91,    93,    46,   286,   287,    59,   123,   125,    40,
      41,    61,    35,    44
};
#endif

#define YYPACT_NINF (-169)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-1)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -169,   115,  -169,  -169,    -5,     7,   -19,  -169,  -169,  -169,
    -169,  -169,     2,  -169,   276,   276,   276,  -169,   176,   276,
    -169,  -169,  -169,  -169,    49,     9,  -169,    10,    34,   333,
     333,  -169,  -169,  -169,  -169,   176,    36,  -169,  -169,   366,
     245,    77,    77,    48,    63,    64,    65,  -169,  -169,  -169,
    -169,  -169,   333,   333,   333,   184,   333,   373,   442,  -169,
    -169,   245,    -4,   609,   -33,  -169,  -169,  -169,  -169,  -169,
      66,    70,  -169,    70,   366,   366,   366,   366,    62,     8,
       8,    67,    69,    81,   289,    79,   517,  -169,    94,    84,
     396,   333,   333,   333,   333,   333,   333,   333,   333,   333,
     333,   333,   333,   333,   333,   333,   124,  -169,  -169,  -169,
     333,  -169,    79,   229,   333,    79,    90,    91,   -18,   -16,
      29,    56,   333,   366,   366,   322,   609,  -169,  -169,  -169,
    -169,   333,  -169,    79,   103,  -169,     5,     5,    51,    51,
     655,   632,   540,     5,     5,    62,    62,     8,     8,     8,
     563,  -169,   245,   609,   366,  -169,  -169,  -169,   609,    77,
    -169,    95,   333,   333,   333,  -169,   419,   -31,    57,    97,
     494,   289,  -169,   333,  -169,  -169,  -169,  -169,   176,   333,
     609,  -169,  -169,  -169,   289,   333,   289,   289,  -169,   333,
    -169,  -169,   609,  -169,   609,   140,   468,  -169,  -169,   586,
     105,   289,   366,  -169,  -169,  -169,    58,   289,  -169
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int8 yydefact[] =
{
       2,     0,     1,    13,     0,     0,     0,    36,    37,    38,
      39,    40,    35,     3,     0,     0,     0,     5,    14,     0,
       4,     8,     7,    23,    24,     0,    21,     0,     0,     0,
       0,    35,    17,    20,    19,    14,     0,    18,    25,    98,
       0,    93,    93,     0,     0,     0,    45,    47,    48,    42,
      43,    44,     0,     0,     0,    89,     0,     0,     0,    15,
       6,     0,    45,   101,     0,    99,    32,    29,    34,    22,
      96,    89,    94,    89,    98,    98,    98,    98,    68,    66,
      67,     0,     0,     0,     0,    89,    90,    91,     0,    89,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    27,    16,    26,
       0,    41,    89,     0,     0,    89,     0,     0,     0,     0,
       0,     0,     0,    98,    98,     0,    87,    84,    86,    79,
      88,     0,    51,    89,     0,    69,    59,    62,    60,    61,
      64,    65,     0,    58,    63,    56,    57,    53,    54,    55,
       0,    46,     0,   102,     0,    33,    31,    30,    97,    88,
       9,     0,     0,    76,    76,    72,     0,     0,     0,     0,
       0,    88,    52,     0,    71,    28,   100,    95,     0,     0,
      73,    77,    74,    75,     0,     0,     0,     0,    85,     0,
      49,    92,    70,    10,    11,    82,     0,    80,    78,     0,
       0,     0,    98,    50,    12,    83,     0,     0,    81
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -169,  -169,     1,  -169,  -169,   118,    46,    -9,  -169,  -169,
    -169,  -169,  -169,  -169,   -57,  -169,  -169,   -29,    -1,   -47,
     -23,  -168,   -35,  -169,   123,    11,   -63,    12
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,    35,   178,   200,    36,    21,    22,    40,    23,
      61,    24,   152,   113,    69,    25,    26,    63,   182,   127,
     128,   129,    88,    89,    71,    72,    64,    65
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_uint8 yytable[] =
{
      57,    58,    20,   191,   109,    32,    33,    34,    87,    27,
      37,   118,   119,   120,   121,   185,   195,   111,   197,   186,
     112,    28,   112,    78,    79,    80,    86,    90,    93,    94,
      29,    68,   162,   205,   163,   112,   116,   112,   117,   208,
     100,   101,   102,   103,   104,    77,   105,   110,   106,   105,
     130,   106,    68,    30,   134,   126,   157,    38,    39,    41,
     167,   168,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   154,   169,   164,
     159,   153,   112,    42,    60,   158,   100,   101,   102,   103,
     104,    70,   105,   166,   106,   175,    90,    74,   171,   102,
     103,   104,   170,   105,    68,   106,   165,   187,   207,   112,
     112,   112,    75,    76,    77,     2,   122,   114,   123,     3,
       4,     5,     6,   115,     7,     8,     9,    10,    11,    12,
     124,    13,    85,   180,   181,   181,   132,   133,   151,   206,
     160,   161,   126,    68,   192,   172,   179,   188,   201,    14,
     194,   204,    15,    59,    16,   126,   196,   126,   180,   156,
     199,    17,    18,   183,   198,    73,   176,    19,     0,     0,
     177,     0,   126,     0,     0,     0,     0,     0,   126,   193,
       3,     4,     5,     6,     0,     7,     8,     9,    10,    11,
      12,    81,     0,    82,    83,    44,    45,    84,    46,    47,
       0,    48,    49,    50,    51,     0,     0,     0,     0,     0,
      14,     0,     0,    15,     0,    16,     0,     0,    52,    53,
      54,     0,    17,    18,     0,    55,     0,     0,    19,     0,
       0,     0,     0,    56,     0,     0,     6,    85,     7,     8,
       9,    10,    11,    12,     0,     0,     0,     0,     0,     0,
       0,     0,     6,     0,     7,     8,     9,    10,    11,    31,
       0,     0,     0,    14,     0,     0,    15,     0,    16,     0,
       0,     0,     0,     0,     0,    66,    67,   155,     0,    14,
       0,    19,    15,     6,    16,     7,     8,     9,    10,    11,
      31,    66,    67,     0,     0,     0,    81,    19,    82,    83,
      44,    45,    84,    46,    47,     0,    48,    49,    50,    51,
      14,     0,     0,    15,     0,    16,     0,     0,     0,     0,
       0,     0,     0,    52,    53,    54,     0,     0,    19,    81,
      55,    82,    83,    44,    45,    84,    46,    47,   125,    48,
      49,    50,    51,    43,    44,    45,     0,    46,    47,     0,
      48,    49,    50,    51,     0,     0,    52,    53,    54,     0,
       0,     0,     0,    55,     0,     0,     0,    52,    53,    54,
       0,    56,     0,     0,    55,     0,    43,    44,    45,     0,
      62,    47,    56,    48,    49,    50,    51,     0,     0,     0,
       0,     0,     0,     0,    91,    92,    93,    94,    95,    96,
      52,    53,    54,    97,     0,    98,    99,    55,   100,   101,
     102,   103,   104,     0,   105,    56,   106,    91,    92,    93,
      94,    95,    96,   107,     0,     0,    97,     0,    98,    99,
       0,   100,   101,   102,   103,   104,     0,   105,     0,   106,
      91,    92,    93,    94,    95,    96,   135,     0,     0,    97,
       0,    98,    99,     0,   100,   101,   102,   103,   104,     0,
     105,     0,   106,    91,    92,    93,    94,    95,    96,   184,
       0,     0,    97,     0,    98,    99,     0,   100,   101,   102,
     103,   104,     0,   105,     0,   106,     0,     0,   108,    91,
      92,    93,    94,    95,    96,     0,     0,     0,    97,     0,
      98,    99,     0,   100,   101,   102,   103,   104,     0,   105,
       0,   106,     0,     0,   202,    91,    92,    93,    94,    95,
      96,     0,     0,     0,    97,   189,    98,    99,     0,   100,
     101,   102,   103,   104,     0,   105,   190,   106,    91,    92,
      93,    94,    95,    96,     0,     0,     0,    97,   131,    98,
      99,     0,   100,   101,   102,   103,   104,     0,   105,     0,
     106,    91,    92,    93,    94,    95,    96,     0,     0,     0,
      97,   173,    98,    99,     0,   100,   101,   102,   103,   104,
       0,   105,     0,   106,    91,    92,    93,    94,    95,    96,
       0,     0,     0,    97,     0,    98,    99,     0,   100,   101,
     102,   103,   104,     0,   105,   174,   106,    91,    92,    93,
      94,    95,    96,     0,     0,     0,    97,     0,    98,    99,
       0,   100,   101,   102,   103,   104,     0,   105,   203,   106,
      91,    92,    93,    94,    95,    96,     0,     0,     0,    97,
       0,    98,    99,     0,   100,   101,   102,   103,   104,     0,
     105,     0,   106,    91,    92,    93,    94,    95,     0,     0,
       0,     0,     0,     0,    98,    99,     0,   100,   101,   102,
     103,   104,     0,   105,     0,   106,    91,    92,    93,    94,
       0,     0,     0,     0,     0,     0,     0,    98,    99,     0,
     100,   101,   102,   103,   104,     0,   105,     0,   106
};

static const yytype_int16 yycheck[] =
{
      29,    30,     1,   171,    61,    14,    15,    16,    55,    14,
      19,    74,    75,    76,    77,    46,   184,    50,   186,    50,
      53,    14,    53,    52,    53,    54,    55,    56,    23,    24,
      49,    40,    50,   201,    50,    53,    71,    53,    73,   207,
      35,    36,    37,    38,    39,    49,    41,    51,    43,    41,
      85,    43,    61,    51,    89,    84,   113,     8,    49,    49,
     123,   124,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   112,   125,    50,
     115,   110,    53,    49,    48,   114,    35,    36,    37,    38,
      39,    14,    41,   122,    43,   152,   125,    49,   133,    37,
      38,    39,   131,    41,   113,    43,    50,    50,    50,    53,
      53,    53,    49,    49,    49,     0,    49,    51,    49,     4,
       5,     6,     7,    53,     9,    10,    11,    12,    13,    14,
      49,    16,    53,   162,   163,   164,    42,    53,    14,   202,
      50,    50,   171,   152,   173,    42,    51,    50,     8,    34,
     179,    46,    37,    35,    39,   184,   185,   186,   187,   113,
     189,    46,    47,   164,   187,    42,   154,    52,    -1,    -1,
     159,    -1,   201,    -1,    -1,    -1,    -1,    -1,   207,   178,
       4,     5,     6,     7,    -1,     9,    10,    11,    12,    13,
      14,     7,    -1,     9,    10,    11,    12,    13,    14,    15,
      -1,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    -1,
      34,    -1,    -1,    37,    -1,    39,    -1,    -1,    34,    35,
      36,    -1,    46,    47,    -1,    41,    -1,    -1,    52,    -1,
      -1,    -1,    -1,    49,    -1,    -1,     7,    53,     9,    10,
      11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     7,    -1,     9,    10,    11,    12,    13,    14,
      -1,    -1,    -1,    34,    -1,    -1,    37,    -1,    39,    -1,
      -1,    -1,    -1,    -1,    -1,    46,    47,    48,    -1,    34,
      -1,    52,    37,     7,    39,     9,    10,    11,    12,    13,
      14,    46,    47,    -1,    -1,    -1,     7,    52,     9,    10,
      11,    12,    13,    14,    15,    -1,    17,    18,    19,    20,
      34,    -1,    -1,    37,    -1,    39,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    34,    35,    36,    -1,    -1,    52,     7,
      41,     9,    10,    11,    12,    13,    14,    15,    49,    17,
      18,    19,    20,    10,    11,    12,    -1,    14,    15,    -1,
      17,    18,    19,    20,    -1,    -1,    34,    35,    36,    -1,
      -1,    -1,    -1,    41,    -1,    -1,    -1,    34,    35,    36,
      -1,    49,    -1,    -1,    41,    -1,    10,    11,    12,    -1,
      14,    15,    49,    17,    18,    19,    20,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    21,    22,    23,    24,    25,    26,
      34,    35,    36,    30,    -1,    32,    33,    41,    35,    36,
      37,    38,    39,    -1,    41,    49,    43,    21,    22,    23,
      24,    25,    26,    50,    -1,    -1,    30,    -1,    32,    33,
      -1,    35,    36,    37,    38,    39,    -1,    41,    -1,    43,
      21,    22,    23,    24,    25,    26,    50,    -1,    -1,    30,
      -1,    32,    33,    -1,    35,    36,    37,    38,    39,    -1,
      41,    -1,    43,    21,    22,    23,    24,    25,    26,    50,
      -1,    -1,    30,    -1,    32,    33,    -1,    35,    36,    37,
      38,    39,    -1,    41,    -1,    43,    -1,    -1,    46,    21,
      22,    23,    24,    25,    26,    -1,    -1,    -1,    30,    -1,
      32,    33,    -1,    35,    36,    37,    38,    39,    -1,    41,
      -1,    43,    -1,    -1,    46,    21,    22,    23,    24,    25,
      26,    -1,    -1,    -1,    30,    31,    32,    33,    -1,    35,
      36,    37,    38,    39,    -1,    41,    42,    43,    21,    22,
      23,    24,    25,    26,    -1,    -1,    -1,    30,    31,    32,
      33,    -1,    35,    36,    37,    38,    39,    -1,    41,    -1,
      43,    21,    22,    23,    24,    25,    26,    -1,    -1,    -1,
      30,    31,    32,    33,    -1,    35,    36,    37,    38,    39,
      -1,    41,    -1,    43,    21,    22,    23,    24,    25,    26,
      -1,    -1,    -1,    30,    -1,    32,    33,    -1,    35,    36,
      37,    38,    39,    -1,    41,    42,    43,    21,    22,    23,
      24,    25,    26,    -1,    -1,    -1,    30,    -1,    32,    33,
      -1,    35,    36,    37,    38,    39,    -1,    41,    42,    43,
      21,    22,    23,    24,    25,    26,    -1,    -1,    -1,    30,
      -1,    32,    33,    -1,    35,    36,    37,    38,    39,    -1,
      41,    -1,    43,    21,    22,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    32,    33,    -1,    35,    36,    37,
      38,    39,    -1,    41,    -1,    43,    21,    22,    23,    24,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    32,    33,    -1,
      35,    36,    37,    38,    39,    -1,    41,    -1,    43
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,    55,     0,     4,     5,     6,     7,     9,    10,    11,
      12,    13,    14,    16,    34,    37,    39,    46,    47,    52,
      56,    60,    61,    63,    65,    69,    70,    14,    14,    49,
      51,    14,    61,    61,    61,    56,    59,    61,     8,    49,
      62,    49,    49,    10,    11,    12,    14,    15,    17,    18,
      19,    20,    34,    35,    36,    41,    49,    71,    71,    59,
      48,    64,    14,    71,    80,    81,    46,    47,    61,    68,
      14,    78,    79,    78,    49,    49,    49,    49,    71,    71,
      71,     7,     9,    10,    13,    53,    71,    73,    76,    77,
      71,    21,    22,    23,    24,    25,    26,    30,    32,    33,
      35,    36,    37,    38,    39,    41,    43,    50,    46,    68,
      51,    50,    53,    67,    51,    53,    76,    76,    80,    80,
      80,    80,    49,    49,    49,    49,    71,    73,    74,    75,
      76,    31,    42,    53,    76,    50,    71,    71,    71,    71,
      71,    71,    71,    71,    71,    71,    71,    71,    71,    71,
      71,    14,    66,    71,    76,    48,    60,    68,    71,    76,
      50,    50,    50,    50,    50,    50,    71,    80,    80,    73,
      71,    76,    42,    31,    42,    68,    81,    79,    57,    51,
      71,    71,    72,    72,    50,    46,    50,    50,    50,    31,
      42,    75,    71,    56,    71,    75,    71,    75,    74,    71,
      58,     8,    46,    42,    46,    75,    80,    50,    75
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_int8 yyr1[] =
{
       0,    54,    55,    55,    55,    56,    56,    56,    56,    57,
      56,    58,    56,    56,    59,    59,    60,    61,    61,    61,
      61,    62,    61,    61,    63,    64,    63,    66,    65,    67,
      67,    67,    68,    68,    68,    69,    69,    69,    69,    69,
      69,    70,    71,    71,    71,    71,    71,    71,    71,    71,
      71,    71,    71,    71,    71,    71,    71,    71,    71,    71,
      71,    71,    71,    71,    71,    71,    71,    71,    71,    71,
      71,    71,    71,    71,    71,    71,    72,    72,    73,    73,
      73,    73,    73,    73,    74,    74,    75,    75,    76,    76,
      77,    77,    77,    78,    78,    78,    79,    79,    80,    80,
      80,    81,    81
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     2,     2,     1,     3,     1,     1,     0,
       8,     0,    10,     1,     0,     2,     4,     2,     2,     2,
       2,     0,     3,     1,     1,     0,     4,     0,     6,     0,
       2,     2,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     4,     1,     1,     1,     1,     3,     1,     1,     5,
       7,     3,     4,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     2,     2,     2,     3,
       5,     4,     4,     5,     5,     5,     0,     1,     5,     2,
       5,     9,     5,     7,     1,     3,     1,     1,     2,     0,
       1,     1,     4,     0,     1,     4,     1,     3,     0,     1,
       4,     1,     3
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

# ifndef YY_LOCATION_PRINT
#  if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#   define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

#  else
#   define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#  endif
# endif /* !defined YY_LOCATION_PRINT */


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  YYUSE (yylocationp);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  YY_LOCATION_PRINT (yyo, *yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yykind, yyvaluep, yylocationp);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)],
                       &(yylsp[(yyi + 1) - (yynrhs)]));
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Location data for the lookahead symbol.  */
YYLTYPE yylloc
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.
       'yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize;

    /* The state stack.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss;
    yy_state_t *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* The locations where the error started and ended.  */
  YYLTYPE yyerror_range[3];



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yynerrs = 0;
  yystate = 0;
  yyerrstatus = 0;

  yystacksize = YYINITDEPTH;
  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;


  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      yyerror_range[1] = yylloc;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 3:
#line 165 "src/parser.y"
            {
              rootmodule->registerUse(std::string((yyvsp[0].text)));
              free((yyvsp[0].text));
            }
#line 1646 "objects/parser.cxx"
    break;

  case 7:
#line 176 "src/parser.y"
            {
              if ((yyvsp[0].inst)) scope_stack.top()->addChild((yyvsp[0].inst));
            }
#line 1654 "objects/parser.cxx"
    break;

  case 9:
#line 181 "src/parser.y"
            {
              UserModule *newmodule = new UserModule((yyvsp[-4].text), LOC((yyloc)));
              newmodule->definition_arguments = *(yyvsp[-2].args);
              scope_stack.top()->addModule((yyvsp[-4].text), newmodule);
              scope_stack.push(&newmodule->scope);
              free((yyvsp[-4].text));
              delete (yyvsp[-2].args);
            }
#line 1667 "objects/parser.cxx"
    break;

  case 10:
#line 190 "src/parser.y"
            {
                scope_stack.pop();
            }
#line 1675 "objects/parser.cxx"
    break;

  case 11:
#line 194 "src/parser.y"
            {
              UserFunction *func = UserFunction::create((yyvsp[-6].text), *(yyvsp[-4].args), shared_ptr<Expression>((yyvsp[0].expr)), LOC((yyloc)));
              scope_stack.top()->addFunction(func);
              free((yyvsp[-6].text));
              delete (yyvsp[-4].args);
            }
#line 1686 "objects/parser.cxx"
    break;

  case 13:
#line 202 "src/parser.y"
            {
                fileEnded=true;
            }
#line 1694 "objects/parser.cxx"
    break;

  case 16:
#line 214 "src/parser.y"
            {
                bool found = false;
                for (auto &assignment : scope_stack.top()->assignments) {
                    if (assignment.name == (yyvsp[-3].text)) {
                        auto mainFile = mainFilePath.string();
                        auto prevFile = assignment.location().fileName();
                        auto currFile = LOC((yyloc)).fileName();
                        
                        const auto uncPathCurr = boostfs_uncomplete(currFile, mainFilePath.parent_path());
                        const auto uncPathPrev = boostfs_uncomplete(prevFile, mainFilePath.parent_path());
                        if(fileEnded){
                            //assigments via commandline
                        }else if(prevFile==mainFile && currFile == mainFile){
                            //both assigments in the mainFile
                            PRINTB("WARNING: %s was assigned on line %i but was overwritten on line %i",
                                    assignment.name%
                                    assignment.location().firstLine()%
                                    LOC((yyloc)).firstLine());
                        }else if(uncPathCurr == uncPathPrev){
                            //assigment overwritten within the same file
                            //the line number being equal happens, when a file is included multiple times
                            if(assignment.location().firstLine() != LOC((yyloc)).firstLine()){
                                PRINTB("WARNING: %s was assigned on line %i of %s but was overwritten on line %i",
                                        assignment.name%
                                        assignment.location().firstLine()%
                                        uncPathPrev%
                                        LOC((yyloc)).firstLine());
                            }
                        }else if(prevFile==mainFile && currFile != mainFile){
                            //assigment from the mainFile overwritten by an include
                            PRINTB("WARNING: %s was assigned on line %i of %s but was overwritten on line %i of %s",
                                    assignment.name%
                                    assignment.location().firstLine()%
                                    uncPathPrev%
                                    LOC((yyloc)).firstLine()%
                                    uncPathCurr);
                        }
                        assignment.expr = shared_ptr<Expression>((yyvsp[-1].expr));
                        assignment.setLocation(LOC((yyloc)));
                        found = true;
                        break;
                    }
                }
                if (!found) {
                  scope_stack.top()->addAssignment(Assignment((yyvsp[-3].text), shared_ptr<Expression>((yyvsp[-1].expr)), LOC((yyloc))));
                }
                free((yyvsp[-3].text));
            }
#line 1747 "objects/parser.cxx"
    break;

  case 17:
#line 266 "src/parser.y"
            {
                (yyval.inst) = (yyvsp[0].inst);
                if ((yyval.inst)) (yyval.inst)->tag_root = true;
            }
#line 1756 "objects/parser.cxx"
    break;

  case 18:
#line 271 "src/parser.y"
            {
                (yyval.inst) = (yyvsp[0].inst);
                if ((yyval.inst)) (yyval.inst)->tag_highlight = true;
            }
#line 1765 "objects/parser.cxx"
    break;

  case 19:
#line 276 "src/parser.y"
            {
                (yyval.inst) = (yyvsp[0].inst);
                if ((yyval.inst)) (yyval.inst)->tag_background = true;
            }
#line 1774 "objects/parser.cxx"
    break;

  case 20:
#line 281 "src/parser.y"
            {
                delete (yyvsp[0].inst);
                (yyval.inst) = NULL;
            }
#line 1783 "objects/parser.cxx"
    break;

  case 21:
#line 286 "src/parser.y"
            {
                (yyval.inst) = (yyvsp[0].inst);
                scope_stack.push(&(yyvsp[0].inst)->scope);
            }
#line 1792 "objects/parser.cxx"
    break;

  case 22:
#line 291 "src/parser.y"
            {
                scope_stack.pop();
                (yyval.inst) = (yyvsp[-1].inst);
            }
#line 1801 "objects/parser.cxx"
    break;

  case 23:
#line 296 "src/parser.y"
            {
                (yyval.inst) = (yyvsp[0].ifelse);
            }
#line 1809 "objects/parser.cxx"
    break;

  case 24:
#line 303 "src/parser.y"
            {
                (yyval.ifelse) = (yyvsp[0].ifelse);
            }
#line 1817 "objects/parser.cxx"
    break;

  case 25:
#line 307 "src/parser.y"
            {
                scope_stack.push(&(yyvsp[-1].ifelse)->else_scope);
            }
#line 1825 "objects/parser.cxx"
    break;

  case 26:
#line 311 "src/parser.y"
            {
                scope_stack.pop();
                (yyval.ifelse) = (yyvsp[-3].ifelse);
            }
#line 1834 "objects/parser.cxx"
    break;

  case 27:
#line 319 "src/parser.y"
            {
                (yyval.ifelse) = new IfElseModuleInstantiation(shared_ptr<Expression>((yyvsp[-1].expr)), main_file_folder, LOC((yyloc)));
                scope_stack.push(&(yyval.ifelse)->scope);
            }
#line 1843 "objects/parser.cxx"
    break;

  case 28:
#line 324 "src/parser.y"
            {
                scope_stack.pop();
                (yyval.ifelse) = (yyvsp[-1].ifelse);
            }
#line 1852 "objects/parser.cxx"
    break;

  case 34:
#line 340 "src/parser.y"
            {
                if ((yyvsp[0].inst)) scope_stack.top()->addChild((yyvsp[0].inst));
            }
#line 1860 "objects/parser.cxx"
    break;

  case 35:
#line 347 "src/parser.y"
                  { (yyval.text) = (yyvsp[0].text); }
#line 1866 "objects/parser.cxx"
    break;

  case 36:
#line 348 "src/parser.y"
                  { (yyval.text) = strdup("for"); }
#line 1872 "objects/parser.cxx"
    break;

  case 37:
#line 349 "src/parser.y"
                  { (yyval.text) = strdup("let"); }
#line 1878 "objects/parser.cxx"
    break;

  case 38:
#line 350 "src/parser.y"
                     { (yyval.text) = strdup("assert"); }
#line 1884 "objects/parser.cxx"
    break;

  case 39:
#line 351 "src/parser.y"
                   { (yyval.text) = strdup("echo"); }
#line 1890 "objects/parser.cxx"
    break;

  case 40:
#line 352 "src/parser.y"
                   { (yyval.text) = strdup("each"); }
#line 1896 "objects/parser.cxx"
    break;

  case 41:
#line 357 "src/parser.y"
            {
                (yyval.inst) = new ModuleInstantiation((yyvsp[-3].text), *(yyvsp[-1].args), main_file_folder, LOC((yyloc)));
                free((yyvsp[-3].text));
                delete (yyvsp[-1].args);
            }
#line 1906 "objects/parser.cxx"
    break;

  case 42:
#line 366 "src/parser.y"
            {
              (yyval.expr) = new Literal(ValuePtr(true), LOC((yyloc)));
            }
#line 1914 "objects/parser.cxx"
    break;

  case 43:
#line 370 "src/parser.y"
            {
              (yyval.expr) = new Literal(ValuePtr(false), LOC((yyloc)));
            }
#line 1922 "objects/parser.cxx"
    break;

  case 44:
#line 374 "src/parser.y"
            {
              (yyval.expr) = new Literal(ValuePtr::undefined, LOC((yyloc)));
            }
#line 1930 "objects/parser.cxx"
    break;

  case 45:
#line 378 "src/parser.y"
            {
              (yyval.expr) = new Lookup((yyvsp[0].text), LOC((yyloc)));
                free((yyvsp[0].text));
            }
#line 1939 "objects/parser.cxx"
    break;

  case 46:
#line 383 "src/parser.y"
            {
              (yyval.expr) = new MemberLookup((yyvsp[-2].expr), (yyvsp[0].text), LOC((yyloc)));
              free((yyvsp[0].text));
            }
#line 1948 "objects/parser.cxx"
    break;

  case 47:
#line 388 "src/parser.y"
            {
              (yyval.expr) = new Literal(ValuePtr(std::string((yyvsp[0].text))), LOC((yyloc)));
              free((yyvsp[0].text));
            }
#line 1957 "objects/parser.cxx"
    break;

  case 48:
#line 393 "src/parser.y"
            {
              (yyval.expr) = new Literal(ValuePtr((yyvsp[0].number)), LOC((yyloc)));
            }
#line 1965 "objects/parser.cxx"
    break;

  case 49:
#line 397 "src/parser.y"
            {
              (yyval.expr) = new Range((yyvsp[-3].expr), (yyvsp[-1].expr), LOC((yyloc)));
            }
#line 1973 "objects/parser.cxx"
    break;

  case 50:
#line 401 "src/parser.y"
            {
              (yyval.expr) = new Range((yyvsp[-5].expr), (yyvsp[-3].expr), (yyvsp[-1].expr), LOC((yyloc)));
            }
#line 1981 "objects/parser.cxx"
    break;

  case 51:
#line 405 "src/parser.y"
            {
              (yyval.expr) = new Literal(ValuePtr(Value::VectorType()), LOC((yyloc)));
            }
#line 1989 "objects/parser.cxx"
    break;

  case 52:
#line 409 "src/parser.y"
            {
              (yyval.expr) = (yyvsp[-2].vec);
            }
#line 1997 "objects/parser.cxx"
    break;

  case 53:
#line 413 "src/parser.y"
            {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::Multiply, (yyvsp[0].expr), LOC((yyloc)));
            }
#line 2005 "objects/parser.cxx"
    break;

  case 54:
#line 417 "src/parser.y"
            {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::Divide, (yyvsp[0].expr), LOC((yyloc)));
            }
#line 2013 "objects/parser.cxx"
    break;

  case 55:
#line 421 "src/parser.y"
            {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::Modulo, (yyvsp[0].expr), LOC((yyloc)));
            }
#line 2021 "objects/parser.cxx"
    break;

  case 56:
#line 425 "src/parser.y"
            {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::Plus, (yyvsp[0].expr), LOC((yyloc)));
            }
#line 2029 "objects/parser.cxx"
    break;

  case 57:
#line 429 "src/parser.y"
            {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::Minus, (yyvsp[0].expr), LOC((yyloc)));
            }
#line 2037 "objects/parser.cxx"
    break;

  case 58:
#line 433 "src/parser.y"
            {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::Less, (yyvsp[0].expr), LOC((yyloc)));
            }
#line 2045 "objects/parser.cxx"
    break;

  case 59:
#line 437 "src/parser.y"
            {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::LessEqual, (yyvsp[0].expr), LOC((yyloc)));
            }
#line 2053 "objects/parser.cxx"
    break;

  case 60:
#line 441 "src/parser.y"
            {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::Equal, (yyvsp[0].expr), LOC((yyloc)));
            }
#line 2061 "objects/parser.cxx"
    break;

  case 61:
#line 445 "src/parser.y"
            {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::NotEqual, (yyvsp[0].expr), LOC((yyloc)));
            }
#line 2069 "objects/parser.cxx"
    break;

  case 62:
#line 449 "src/parser.y"
            {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::GreaterEqual, (yyvsp[0].expr), LOC((yyloc)));
            }
#line 2077 "objects/parser.cxx"
    break;

  case 63:
#line 453 "src/parser.y"
            {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::Greater, (yyvsp[0].expr), LOC((yyloc)));
            }
#line 2085 "objects/parser.cxx"
    break;

  case 64:
#line 457 "src/parser.y"
            {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::LogicalAnd, (yyvsp[0].expr), LOC((yyloc)));
            }
#line 2093 "objects/parser.cxx"
    break;

  case 65:
#line 461 "src/parser.y"
            {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::LogicalOr, (yyvsp[0].expr), LOC((yyloc)));
            }
#line 2101 "objects/parser.cxx"
    break;

  case 66:
#line 465 "src/parser.y"
            {
                (yyval.expr) = (yyvsp[0].expr);
            }
#line 2109 "objects/parser.cxx"
    break;

  case 67:
#line 469 "src/parser.y"
            {
              (yyval.expr) = new UnaryOp(UnaryOp::Op::Negate, (yyvsp[0].expr), LOC((yyloc)));
            }
#line 2117 "objects/parser.cxx"
    break;

  case 68:
#line 473 "src/parser.y"
            {
              (yyval.expr) = new UnaryOp(UnaryOp::Op::Not, (yyvsp[0].expr), LOC((yyloc)));
            }
#line 2125 "objects/parser.cxx"
    break;

  case 69:
#line 477 "src/parser.y"
            {
              (yyval.expr) = (yyvsp[-1].expr);
            }
#line 2133 "objects/parser.cxx"
    break;

  case 70:
#line 481 "src/parser.y"
            {
              (yyval.expr) = new TernaryOp((yyvsp[-4].expr), (yyvsp[-2].expr), (yyvsp[0].expr), LOC((yyloc)));
            }
#line 2141 "objects/parser.cxx"
    break;

  case 71:
#line 485 "src/parser.y"
            {
              (yyval.expr) = new ArrayLookup((yyvsp[-3].expr), (yyvsp[-1].expr), LOC((yyloc)));
            }
#line 2149 "objects/parser.cxx"
    break;

  case 72:
#line 489 "src/parser.y"
            {
              (yyval.expr) = new FunctionCall((yyvsp[-3].text), *(yyvsp[-1].args), LOC((yyloc)));
              free((yyvsp[-3].text));
              delete (yyvsp[-1].args);
            }
#line 2159 "objects/parser.cxx"
    break;

  case 73:
#line 495 "src/parser.y"
            {
              (yyval.expr) = FunctionCall::create("let", *(yyvsp[-2].args), (yyvsp[0].expr), LOC((yyloc)));
              delete (yyvsp[-2].args);
            }
#line 2168 "objects/parser.cxx"
    break;

  case 74:
#line 500 "src/parser.y"
            {
              (yyval.expr) = FunctionCall::create("assert", *(yyvsp[-2].args), (yyvsp[0].expr), LOC((yyloc)));
              delete (yyvsp[-2].args);
            }
#line 2177 "objects/parser.cxx"
    break;

  case 75:
#line 505 "src/parser.y"
            {
              (yyval.expr) = FunctionCall::create("echo", *(yyvsp[-2].args), (yyvsp[0].expr), LOC((yyloc)));
              delete (yyvsp[-2].args);
            }
#line 2186 "objects/parser.cxx"
    break;

  case 76:
#line 513 "src/parser.y"
            {
              (yyval.expr) = NULL;
            }
#line 2194 "objects/parser.cxx"
    break;

  case 77:
#line 517 "src/parser.y"
            {
              (yyval.expr) = (yyvsp[0].expr);
            }
#line 2202 "objects/parser.cxx"
    break;

  case 78:
#line 526 "src/parser.y"
            {
              (yyval.expr) = new LcLet(*(yyvsp[-2].args), (yyvsp[0].expr), LOC((yyloc)));
              delete (yyvsp[-2].args);
            }
#line 2211 "objects/parser.cxx"
    break;

  case 79:
#line 531 "src/parser.y"
            {
              (yyval.expr) = new LcEach((yyvsp[0].expr), LOC((yyloc)));
            }
#line 2219 "objects/parser.cxx"
    break;

  case 80:
#line 535 "src/parser.y"
            {
                (yyval.expr) = (yyvsp[0].expr);

                /* transform for(i=...,j=...) -> for(i=...) for(j=...) */
                for (int i = (yyvsp[-2].args)->size()-1; i >= 0; i--) {
                  AssignmentList arglist;
                  arglist.push_back((*(yyvsp[-2].args))[i]);
                  Expression *e = new LcFor(arglist, (yyval.expr), LOC((yyloc)));
                    (yyval.expr) = e;
                }
                delete (yyvsp[-2].args);
            }
#line 2236 "objects/parser.cxx"
    break;

  case 81:
#line 548 "src/parser.y"
            {
              (yyval.expr) = new LcForC(*(yyvsp[-6].args), *(yyvsp[-2].args), (yyvsp[-4].expr), (yyvsp[0].expr), LOC((yyloc)));
                delete (yyvsp[-6].args);
                delete (yyvsp[-2].args);
            }
#line 2246 "objects/parser.cxx"
    break;

  case 82:
#line 554 "src/parser.y"
            {
              (yyval.expr) = new LcIf((yyvsp[-2].expr), (yyvsp[0].expr), 0, LOC((yyloc)));
            }
#line 2254 "objects/parser.cxx"
    break;

  case 83:
#line 558 "src/parser.y"
            {
              (yyval.expr) = new LcIf((yyvsp[-4].expr), (yyvsp[-2].expr), (yyvsp[0].expr), LOC((yyloc)));
            }
#line 2262 "objects/parser.cxx"
    break;

  case 85:
#line 567 "src/parser.y"
            {
                (yyval.expr) = (yyvsp[-1].expr);
            }
#line 2270 "objects/parser.cxx"
    break;

  case 90:
#line 584 "src/parser.y"
            {
              (yyval.vec) = new Vector(LOC((yyloc)));
              (yyval.vec)->push_back((yyvsp[0].expr));
            }
#line 2279 "objects/parser.cxx"
    break;

  case 91:
#line 589 "src/parser.y"
            {
              (yyval.vec) = new Vector(LOC((yyloc)));
              (yyval.vec)->push_back((yyvsp[0].expr));
            }
#line 2288 "objects/parser.cxx"
    break;

  case 92:
#line 594 "src/parser.y"
            {
              (yyval.vec) = (yyvsp[-3].vec);
              (yyval.vec)->push_back((yyvsp[0].expr));
            }
#line 2297 "objects/parser.cxx"
    break;

  case 93:
#line 602 "src/parser.y"
            {
                (yyval.args) = new AssignmentList();
            }
#line 2305 "objects/parser.cxx"
    break;

  case 94:
#line 606 "src/parser.y"
            {
                (yyval.args) = new AssignmentList();
                (yyval.args)->push_back(*(yyvsp[0].arg));
                delete (yyvsp[0].arg);
            }
#line 2315 "objects/parser.cxx"
    break;

  case 95:
#line 612 "src/parser.y"
            {
                (yyval.args) = (yyvsp[-3].args);
                (yyval.args)->push_back(*(yyvsp[0].arg));
                delete (yyvsp[0].arg);
            }
#line 2325 "objects/parser.cxx"
    break;

  case 96:
#line 621 "src/parser.y"
            {
                (yyval.arg) = new Assignment((yyvsp[0].text), LOC((yyloc)));
                free((yyvsp[0].text));
            }
#line 2334 "objects/parser.cxx"
    break;

  case 97:
#line 626 "src/parser.y"
            {
              (yyval.arg) = new Assignment((yyvsp[-2].text), shared_ptr<Expression>((yyvsp[0].expr)), LOC((yyloc)));
                free((yyvsp[-2].text));
            }
#line 2343 "objects/parser.cxx"
    break;

  case 98:
#line 634 "src/parser.y"
            {
                (yyval.args) = new AssignmentList();
            }
#line 2351 "objects/parser.cxx"
    break;

  case 99:
#line 638 "src/parser.y"
            {
                (yyval.args) = new AssignmentList();
                (yyval.args)->push_back(*(yyvsp[0].arg));
                delete (yyvsp[0].arg);
            }
#line 2361 "objects/parser.cxx"
    break;

  case 100:
#line 644 "src/parser.y"
            {
                (yyval.args) = (yyvsp[-3].args);
                (yyval.args)->push_back(*(yyvsp[0].arg));
                delete (yyvsp[0].arg);
            }
#line 2371 "objects/parser.cxx"
    break;

  case 101:
#line 653 "src/parser.y"
            {
                (yyval.arg) = new Assignment("", shared_ptr<Expression>((yyvsp[0].expr)), LOC((yyloc)));
            }
#line 2379 "objects/parser.cxx"
    break;

  case 102:
#line 657 "src/parser.y"
            {
                (yyval.arg) = new Assignment((yyvsp[-2].text), shared_ptr<Expression>((yyvsp[0].expr)), LOC((yyloc)));
                free((yyvsp[-2].text));
            }
#line 2388 "objects/parser.cxx"
    break;


#line 2392 "objects/parser.cxx"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  yyerror_range[1] = yylloc;
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  ++yylsp;
  YYLLOC_DEFAULT (*yylsp, yyerror_range, 2);

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif


/*-----------------------------------------------------.
| yyreturn -- parsing is finished, return the result.  |
`-----------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 663 "src/parser.y"


int parserlex(void)
{
  return lexerlex();
}

void yyerror (char const *s)
{
  // FIXME: We leak memory on parser errors...
  PRINTB("ERROR: Parser error in file %s, line %d: %s\n",
         (*sourcefile()) % lexerget_lineno() % s);
}

bool parse(FileModule *&module, const std::string& text, const std::string &filename, const std::string &mainFile, int debug)
{
  fs::path parser_sourcefile = fs::path(fs::absolute(fs::path(filename)).generic_string());
  main_file_folder = parser_sourcefile.parent_path().string();
  lexer_set_parser_sourcefile(parser_sourcefile);
  mainFilePath = fs::absolute(fs::path(mainFile));

  lexerin = NULL;
  parser_error_pos = -1;
  parser_input_buffer = text.c_str();
  fileEnded=false;

  rootmodule = new FileModule(main_file_folder, parser_sourcefile.filename().string());
  scope_stack.push(&rootmodule->scope);
  //        PRINTB_NOCACHE("New module: %s %p", "root" % rootmodule);

  parserdebug = debug;
  int parserretval = -1;
  try{
     parserretval = parserparse();
  }catch (const HardWarningException &e) {
    yyerror("stop on first warning");
  }

  lexerdestroy();
  lexerlex_destroy();

  module = rootmodule;
  if (parserretval != 0) return false;

  parser_error_pos = -1;
  parser_input_buffer = nullptr;
  scope_stack.pop();

  return true;
}
